var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { componentDefaultProps } from './component-common';
import FormCheckGroup from './form-check-group';
var CheckboxGroup = /** @class */ (function (_super) {
    __extends(CheckboxGroup, _super);
    function CheckboxGroup(props) {
        var _this = _super.call(this, props) || this;
        // Returns an array of the values of all checked items.
        _this.handleChange = function () {
            var _a = _this.props, options = _a.options, name = _a.name, onSetValue = _a.onSetValue, changeCallback = _a.changeCallback;
            var checkedOptions = options.filter(function (option) { return _this.elements[option.value].checked; });
            var value = checkedOptions.map(function (option) { return option.value; });
            onSetValue(value);
            changeCallback(name, value);
        };
        _this.renderElement = function () {
            var _a = _this.props, disabled = _a.disabled, errorMessages = _a.errorMessages, id = _a.id, options = _a.options, required = _a.required, showErrors = _a.showErrors, type = _a.type, value = _a.value;
            var markAsInvalid = showErrors && (errorMessages.length > 0 || required);
            var className = "form-check" + (type === 'inline' ? ' form-check-inline' : '');
            var inputClassName = "form-check-input" + (markAsInvalid ? ' is-invalid' : '');
            var controls = options.map(function (checkbox) {
                var checked = value.indexOf(checkbox.value) !== -1;
                var isDisabled = checkbox.disabled || disabled;
                var inputId = id + "--" + checkbox.value;
                return (React.createElement("div", { className: className, key: checkbox.value },
                    React.createElement("input", { ref: function (input) {
                            _this.elements[checkbox.value] = input;
                        }, className: inputClassName, checked: checked, type: "checkbox", value: checkbox.value, onChange: _this.handleChange, disabled: isDisabled, id: inputId, required: required }),
                    React.createElement("label", { className: "form-check-label", htmlFor: inputId }, checkbox.label)));
            });
            return controls;
        };
        _this.elements = {};
        return _this;
    }
    CheckboxGroup.prototype.render = function () {
        return (React.createElement(FormCheckGroup, __assign({}, this.props),
            React.createElement(React.Fragment, null, this.renderElement())));
    };
    CheckboxGroup.defaultProps = __assign({}, componentDefaultProps, { options: [], value: [] });
    return CheckboxGroup;
}(React.Component));
export default CheckboxGroup;
//# sourceMappingURL=checkbox-group.js.map