import * as React from 'react';
import { CommonProps as CommonControlProps } from './controls/common-prop-types';
import { ComponentPropTypes } from './component-common';
declare type CommonControlPropsCleaned = Omit<CommonControlProps, 'id' | 'name'>;
interface Props extends ComponentPropTypes, CommonControlPropsCleaned {
    value: boolean;
    valueLabel: string;
}
declare class Checkbox extends React.Component<Props, {}> {
    element: any;
    static defaultProps: {
        value: boolean;
        valueLabel: string;
        changeCallback: (name: string, value: any) => void;
        onSetValue: (value: any) => void;
        errorMessages: never[];
        help: string;
        label: null;
        layout: "horizontal" | "vertical" | "elementOnly";
        showErrors: boolean;
        rowClassName: string;
        labelClassName: string;
        elementWrapperClassName: string;
        isPristine: () => boolean;
    };
    private handleChange;
    private initElementRef;
    private renderElement;
    render(): JSX.Element;
}
export default Checkbox;
