var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { ComponentPropKeys, componentDefaultProps, } from './component-common';
import ErrorMessages from './error-messages';
import Help from './help';
import Row from './row';
import FileControl from './controls/input-file';
var File = /** @class */ (function (_super) {
    __extends(File, _super);
    function File() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = function (event) {
            var target = event.currentTarget;
            var value = target.value;
            var _a = _this.props, onSetValue = _a.onSetValue, changeCallback = _a.changeCallback, name = _a.name;
            onSetValue(target.files);
            // We're passing an additional argument to the changeCallback handler here,
            // the 'value' of the field. This value is actually pretty useless,
            // and we're only including here for completeness.
            // An example value would be: "C:\fakepath\name-of-file.txt". Note that
            // if we select multiple files, it only returns a "fakepath" string for
            // the first file.
            // A web search for "C:\fakepath\" gives more details.
            changeCallback(name, target.files, value);
        };
        _this.initElementRef = function (control) {
            _this.element = control ? control.element : null;
        };
        return _this;
    }
    File.prototype.render = function () {
        var inputProps = Object.assign({ className: 'form-control-file' }, this.props);
        ComponentPropKeys.forEach(function (key) {
            delete inputProps[key];
        });
        var _a = this.props, layout = _a.layout, id = _a.id, showErrors = _a.showErrors, help = _a.help, errorMessages = _a.errorMessages;
        var control = (React.createElement(FileControl, __assign({}, inputProps, { onChange: this.handleChange, ref: this.initElementRef })));
        if (layout === 'elementOnly') {
            return control;
        }
        return (React.createElement(Row, __assign({}, this.props, { htmlFor: id }),
            React.createElement(React.Fragment, null,
                control,
                help ? React.createElement(Help, { help: help }) : null,
                showErrors ? React.createElement(ErrorMessages, { messages: errorMessages }) : null)));
    };
    File.defaultProps = __assign({}, componentDefaultProps);
    return File;
}(React.Component));
export default File;
//# sourceMappingURL=input-file.js.map