import * as React from 'react';
/**
 * Wraps an input to implement a Bootstrap [Input Group](http://getbootstrap.com/components/#input-groups)
 */
var InputGroup = function (props) {
    var renderAddon = function (addon, position) {
        if (!addon) {
            return null;
        }
        return React.createElement("span", { className: "input-group-" + position }, addon);
    };
    var addonBefore = props.addonBefore, addonAfter = props.addonAfter, buttonBefore = props.buttonBefore, buttonAfter = props.buttonAfter, children = props.children;
    return (React.createElement("div", { className: "input-group" },
        renderAddon(addonBefore, 'prepend'),
        renderAddon(buttonBefore, 'prepend'),
        children,
        renderAddon(addonAfter, 'append'),
        renderAddon(buttonAfter, 'append')));
};
InputGroup.defaultProps = {
    addonAfter: null,
    addonBefore: null,
    buttonAfter: null,
    buttonBefore: null,
};
export default InputGroup;
//# sourceMappingURL=input-group.js.map