import * as React from 'react';
import { ComponentPropTypes } from './component-common';
import { CommonProps as ControlCommonProps } from './controls/common-prop-types';
declare type ControlCommonPropsCleaned = Omit<ControlCommonProps, 'id' | 'name'>;
interface Props extends ComponentPropTypes, ControlCommonPropsCleaned {
    options: {
        disabled: boolean;
        value: string;
        label: React.ReactNode;
    }[];
    required: boolean;
    value: string;
    type: 'inline' | 'stacked';
}
declare class RadioGroup extends React.Component<Props, {}> {
    elements: any;
    static defaultProps: {
        type: string;
        options: never[];
        changeCallback: (name: string, value: any) => void;
        onSetValue: (value: any) => void;
        errorMessages: never[];
        help: string;
        label: null;
        layout: "horizontal" | "vertical" | "elementOnly";
        showErrors: boolean;
        rowClassName: string;
        labelClassName: string;
        elementWrapperClassName: string;
        isPristine: () => boolean;
    };
    constructor(props: any);
    private handleChange;
    private renderElement;
    render(): JSX.Element;
}
export default RadioGroup;
