import * as React from 'react';
import classNames from 'classnames/dedupe';
import Label from './label';
var Row = function (_a) {
    var children = _a.children, _b = _a.elementWrapperClassName, elementWrapperClassName = _b === void 0 ? '' : _b, _c = _a.errorMessages, errorMessages = _c === void 0 ? [] : _c, _d = _a.fakeLabel, fakeLabel = _d === void 0 ? false : _d, _e = _a.htmlFor, htmlFor = _e === void 0 ? '' : _e, _f = _a.label, label = _f === void 0 ? null : _f, _g = _a.labelClassName, labelClassName = _g === void 0 ? '' : _g, _h = _a.layout, layout = _h === void 0 ? 'horizontal' : _h, _j = _a.required, required = _j === void 0 ? false : _j, _k = _a.rowClassName, rowClassName = _k === void 0 ? '' : _k, _l = _a.showErrors, showErrors = _l === void 0 ? false : _l;
    var element = children;
    if (layout === 'elementOnly') {
        return React.createElement("span", null, element);
    }
    var cssClasses = {
        row: ['form-group'],
        elementWrapper: [],
    };
    if (showErrors && (errorMessages.length > 0 || required)) {
        cssClasses.row.push('text-danger');
    }
    // We should render the label if there is label text defined, or if the
    // component is required (so a required symbol is displayed in the label tag)
    var shouldRenderLabel = label !== null || required;
    if (layout === 'horizontal') {
        cssClasses.row.push('form-row');
        if (!shouldRenderLabel) {
            cssClasses.elementWrapper.push('offset-sm-3');
        }
        cssClasses.elementWrapper.push('col-sm-9');
        cssClasses.elementWrapper.push(elementWrapperClassName);
        element = (React.createElement("div", { className: classNames(cssClasses.elementWrapper) }, element));
    }
    cssClasses.row.push(rowClassName);
    return (React.createElement("div", { className: classNames(cssClasses.row) },
        shouldRenderLabel ? (React.createElement(Label, { fakeLabel: fakeLabel, htmlFor: htmlFor, label: label, labelClassName: labelClassName, layout: layout, required: required })) : null,
        element));
};
export default Row;
//# sourceMappingURL=row.js.map