var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { ComponentPropKeys, componentDefaultProps, } from './component-common';
import ErrorMessages from './error-messages';
import Help from './help';
import Row from './row';
import SelectControl from './controls/select';
var Select = /** @class */ (function (_super) {
    __extends(Select, _super);
    function Select() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleChange = function (event) {
            var target = event.currentTarget;
            var _a = _this.props, multiple = _a.multiple, onSetValue = _a.onSetValue, changeCallback = _a.changeCallback, name = _a.name;
            var value;
            if (multiple) {
                value = Array.from(target.options)
                    .filter(function (option) { return option.selected; })
                    .map(function (option) { return option.value; });
            }
            else {
                (value = target.value);
            }
            onSetValue(value);
            changeCallback(name, value);
        };
        _this.initElementRef = function (control) {
            _this.element = control ? control.element : null;
        };
        return _this;
    }
    Select.prototype.render = function () {
        var inputProps = Object.assign({}, this.props);
        ComponentPropKeys.forEach(function (key) {
            delete inputProps[key];
        });
        var control = (React.createElement(SelectControl, __assign({}, inputProps, { onChange: this.handleChange, ref: this.initElementRef })));
        var _a = this.props, layout = _a.layout, id = _a.id, help = _a.help, showErrors = _a.showErrors, errorMessages = _a.errorMessages;
        if (layout === 'elementOnly') {
            return control;
        }
        return (React.createElement(Row, __assign({}, this.props, { htmlFor: id }),
            React.createElement(React.Fragment, null,
                control,
                help ? React.createElement(Help, { help: help }) : null,
                showErrors ? React.createElement(ErrorMessages, { messages: errorMessages }) : null)));
    };
    Select.defaultProps = __assign({}, componentDefaultProps, { options: [], multiple: false });
    return Select;
}(React.Component));
export default Select;
//# sourceMappingURL=select.js.map