import * as React from 'react';
import { ComponentPropTypes } from './component-common';
import { TextareaControlProps } from './controls/textarea';
declare const defaultProps: {
    value: string;
    updateOnBlur: boolean;
    updateOnChange: boolean;
    blurDebounceInterval: number;
    changeDebounceInterval: number;
    blurCallback: (name: any, value: any) => void;
    changeCallback: (name: string, value: any) => void;
    onSetValue: (value: any) => void;
    errorMessages: never[];
    help: string;
    label: null;
    layout: "horizontal" | "vertical" | "elementOnly";
    showErrors: boolean;
    rowClassName: string;
    labelClassName: string;
    elementWrapperClassName: string;
    isPristine: () => boolean;
};
declare type Props = ComponentPropTypes & TextareaControlProps & typeof defaultProps;
interface State {
    value: string;
}
declare class Textarea extends React.Component<Props, State> {
    element: any;
    private changeDebounced;
    private blurDebounced;
    static defaultProps: {
        value: string;
        updateOnBlur: boolean;
        updateOnChange: boolean;
        blurDebounceInterval: number;
        changeDebounceInterval: number;
        blurCallback: (name: any, value: any) => void;
        changeCallback: (name: string, value: any) => void;
        onSetValue: (value: any) => void;
        errorMessages: never[];
        help: string;
        label: null;
        layout: "horizontal" | "vertical" | "elementOnly";
        showErrors: boolean;
        rowClassName: string;
        labelClassName: string;
        elementWrapperClassName: string;
        isPristine: () => boolean;
    };
    constructor(props: any);
    componentWillReceiveProps: (nextProps: any) => void;
    private handleChange;
    private handleBlur;
    private initElementRef;
    render(): JSX.Element;
}
export default Textarea;
