import * as React from 'react';
import Formsy from 'formsy-react';
import { ClassValue } from 'classnames/types';
/**
 * Formsy props taken from:
 *
 * - https://github.com/formsy/formsy-react/blob/master/API.md#formsy
 */
interface FormsyProps {
    mapping?: Function;
    validationErrors?: Function;
    onSubmit?: Function;
    onValid?: Function;
    onInvalid?: Function;
    onValidSubmit?: Function;
    onInvalidSubmit?: Function;
    onChange?: Function;
    preventExternalInvalidation?: boolean;
}
export interface Props extends FormsyProps {
    children: React.ReactNode;
    layout: 'horizontal' | 'vertical' | 'elementOnly';
    className: ClassValue;
    validateBeforeSubmit: boolean;
    validatePristine: boolean;
    elementWrapperClassName: ClassValue;
    labelClassName: ClassValue;
    rowClassName: ClassValue;
    disabled: boolean;
}
declare class Form extends React.Component<Props, {}> {
    formsyForm: React.RefObject<Formsy>;
    static defaultProps: {
        layout: string;
        className: string;
        elementWrapperClassName: string;
        labelClassName: string;
        rowClassName: string;
        validateBeforeSubmit: boolean;
        validatePristine: boolean;
        disabled: boolean;
    };
    render(): JSX.Element;
}
export default Form;
